<template>
  <div class="product-details">
    <div class="container pt-4">
      <div class="row mb-3" v-if="product">
        <div class="col-sm-12 col-md-12 col-lg-6 mb-3">
          <div class="product-image d-flex" >
            <div class="images-list">
              <div v-for="file in product.files.filter(f => !f.video)" :class="{'active': mainImg === file.url}" @mouseover="changeMainImage(file.url)">
                <div class="overlay"></div>
                <img :src="file.url"></img>
              </div>
              <div v-if="product.files.find(f => f.video)" @click="openVideoFull">
                <video width="100" autoplay loop muted controls id="product-video">
                  <source :src="product.files.find(f => f.video).url" type="video/mp4">
                  Your browser does not support HTML5 video.
                </video>
              </div>
            </div>
            <div class="view hm-zoom z-depth-2" style="cursor: pointer">
              <div>
                <img
                  :src="mainImg"
                  :alt="product.productName"
                  class="img-fluid rounded"
                  style="max-height: 700px;margin: auto"
                >
              </div>
            </div>
          </div>
        </div>
        <div class="col-sm-12 col-md-12 col-lg-6">
          <div class="product-detail">
            <div class="sale-sticker" v-if="product.discount"><span>SALE</span></div>
            <p class="product-category">{{product.productCategory}}</p>
            <h4>{{product.productName}}</h4>
            <p>{{product.productDescription}}</p>

            <div class="d-flex">
              <p class="product-price" :class="{'old-price': product.discount && cartItem.selectedItem}" v-text="getPrice()"></p>
              <p v-if="product.discount && cartItem.selectedItem" class="ml-2 product-price new-price" v-text="getPrice(true)"></p>
            </div>

            <h5>Размер</h5>
            <div class="swatch d-flex">
              <div class="swatch-element mr-1" v-for="item in product.items">
                <input type="radio" :id="`swatch-1-${item._id}`" :disabled="Number(item.quantity) === 0"" name="size" v-model="cartItem.selectedItem" :value="item._id" :checked="cartItem.selectedItem === item._id">
                <label :for="`swatch-1-${item._id}`">
                  {{item.type}}
                  
                  <img class="crossed-out" v-if="Number(item.quantity) === 0" :src="`${staticURL}/src/assets/soldout.png`">
                </label>
              </div>
            </div>

            <button class="action-button black-button" :disabled="!cartItem.selectedItem" v-on:click="addToCart(cartItem)">В КОРЗИНУ</button>
          </div>
        </div>
      </div>
    </div>
    <h4 class="panel-break">также может понравиться</h4>
    <div class="container">
      <div class="row">
        <div class="col-6 col-sm-6 col-md-4 col-lg-3 mt-3" v-for="(item, index) in similarProduct" :key="index">
          <card-template :item="item"/>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import { mapMutations } from "vuex";
import CardTemplate from "../shared/CardTemplate";

export default {
  name: "productDetail",
  components: { CardTemplate },
  data() {
    return {
      staticURL: process.env.VUE_APP_STATIC_URL,
      cartItem: undefined, mainImg: undefined,
      product: undefined,
      similarProduct: []
    };
  },
  methods: {
    getSimilarProduct(productCategory) {
      axios
        .get(`${process.env.VUE_APP_BASE_URL}/products/similar-product`, {
          params: { productCategory: productCategory }
        })
        .then(response => {
          this.similarProduct = response.data;
        })
        .catch(error => {
          console.log(error);
        });
    },
    ...mapMutations(["ADD_CART_LOCAL"]),
    addToCart(product) {
      this.ADD_CART_LOCAL(product);
      this.$emit('addToCart');
    },
    getPrice(dicount) {
      if (!this.cartItem.selectedItem) {
        return 'Не осталось в наличии';
      } else {
        if (dicount) {
          let price = this.product.items.find(i => i._id === this.cartItem.selectedItem).price;

          price = parseFloat(price) - (price * (this.product.discount / 100));
          return `${price} UAH`;
        } else {
          let price = this.product.items.find(i => i._id === this.cartItem.selectedItem).price;
          return `${price} UAH`;
        }
      }
    },
    getSelectedProduct() {
      this.$http
        .get(`${process.env.VUE_APP_BASE_URL}/products/${this.$route.params.id}`)
        .then(response => {
          this.product = response.data;
          this.mainImg = this.product.files.find(f => f.main).url;
          const starTotal = 5;
          this.getSimilarProduct(this.product.productCategory);


          let cartSelectedItem = this.product.items.find(i => Number(i.quantity) !== 0);
          this.cartItem = {
            productId: this.product._id,
            selectedItem: cartSelectedItem ? cartSelectedItem._id : undefined,
            cartItemId: generateId()
          };
        })
        .catch(error => {
          console.log(error);
        });
    },
    changeMainImage(img) {
      console.log('this fires');
      this.mainImg = img;
    },
    openVideoFull() {
      let elem = document.getElementById("product-video");
      if (elem.requestFullscreen) {
        elem.requestFullscreen();
      } else if (elem.mozRequestFullScreen) {
        elem.mozRequestFullScreen();
      } else if (elem.webkitRequestFullscreen) {
        elem.webkitRequestFullscreen();
      } else if (elem.msRequestFullscreen) { 
        elem.msRequestFullscreen();
      }
    }
  },
  created() {
    this.getSelectedProduct();
  }
};

function generateId() {
  let timestamp = (new Date().getTime() / 1000 | 0).toString(16);
  return timestamp + 'xxxxxxxxxxxxxxxx'.replace(/[x]/g, function() {
    return (Math.random() * 16 | 0).toString(16);
  }).toLowerCase();
}

</script>

<style lang="scss">
.product-details {
  margin-top: 70px;
  background-color: #f9f9f9;
  position: relative;
}
.images-list {
  max-width: 100px;
  display: flex;
  flex-direction: column;
  margin-right: 10px;

  & > div {
    margin-bottom: 10px;
    position: relative;
    img {
      width: 100%;
      height: 100%;
    }

    .overlay {
      position: absolute;
      top: 0;
      right: 0;
      left: 0;
      bottom: 0;
      background-color: #000;
      opacity: 0.2;
    }
  }
  & .active .overlay {
    display: none;
  }
}
.product-detail {
  font-size: 14px;
  padding: 30px;
  border: 1px solid lightgray;
  background-color: #fff;

  .product-category, .product-price {
    font-size: 12px;
    font-style: italic;
    color: gray;
  }

  .product-price {
    font-size: 16px;
  }
  .new-price {
    color: red;
  }
}

.swatch {
  input {
    display: none;

    &:checked + label {
      border: 1px solid #393c4a;
      background: #28323c;
      color: #ffffff;
    }
  }
  label {
    color: #000000;
    background-color: #ffffff;
    border: 1px solid #d5d5d5;
    display: -moz-inline-stack;
    display: inline-block;
    zoom: 1;
    padding: 0;
    margin: 0px 5px 10px 0;
    margin-right: 0 !important;
    margin-bottom: 0 !important;
    cursor: pointer;
    position: relative;
    font-size: 13px;
    min-width: 40px;
    height: 38px;
    line-height: 38px;
    white-space: nowrap;
    text-align: center;
  }
  img {
    position: absolute;
    width: 100%;
    height: 100%;
    left: 0;
    top: 0;
    z-index: 1;
  }
  
}
#product-video {
  cursor: pointer;
}

@media (max-width: 992px) {
  .product-details {
    margin-top: 0;
  }
}
</style>
